明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 1040|回复: 16

[源码] 工作需要做了两个LSP 发给有缘人

  [复制链接]
发表于 2021-6-6 20:35 | 显示全部楼层 |阅读模式
工作需要写出dxf文件,因此先做成图块,块名通过点选提取,然后将图块批量写出
(defun c:BN (/ ss pt0 name)
  (setvar "cmdecho" 0)
  (setq
    name (cdr (assoc 1 (entget (car (nentsel "\n点选单行文字:")))))
  )
  (setq ss nil)
  (setq ss (ssget))
  (setq pt0 (getpoint "\n指定插入点:"))
  (command "block" name pt0 ss "")
  (command "-insert" name pt0 1 1 0)
  (princ)
)

(defun c:wb(/ qf_getFolder filename blkss folder1 i oldenv)
  (setvar "cmdecho" 0)
  (setq oldenv (getenv "DefaultFormatForSave"))
  (setenv "DefaultFormatForSave" "1")
;;;定义选择文件夹对话框子函数
  (defun qf_getFolder (msg / WinShell shFolder path catchit)
    (vl-load-com)
    (setq winshell (vlax-create-object "Shell.Application"))
    (setq
      shFolder (vlax-invoke-method WinShell 'BrowseForFolder 0 msg 1)
    )
    (setq
      catchit (vl-catch-all-apply
                '(lambda ()
                   (setq shFolder (vlax-get-property shFolder 'self))
                   (setq path (vlax-get-property shFolder 'path))
                 )
              )
    )
    (if        (vl-catch-all-error-p catchit)
      nil
      path
    )
  )

(setq folder1 (qf_getFolder "选择分图文件夹:"))
(setq blkss (ssget '((0 . "insert"))))
(setq i 0)
(while (< i (sslength blkss))
(setq filename (strcat folder1 "\\" (vla-get-name (vlax-ename->vla-object (ssname blkss i))) ".dxf"))
(vl-file-delete  filename)
;(vl-cmdf ".-wblock" filename "" "=" (list 0 0 0) (ssname blkss i) "" "oops")
  (vl-cmdf ".-wblock" filename "" "=" "oops")
  (setq i (1+ i)))
  (setenv "DefaultFormatForSave" oldenv)
  (princ))


本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x

评分

参与人数 5明经币 +5 收起 理由
tryhi + 1 赞一个!
树櫴希德 + 1 很给力!
songyujie928 + 1 赞一个!
start4444 + 1 赞一个!
tigcat + 1 很给力!

查看全部评分

发表于 2021-6-6 21:41 | 显示全部楼层
谢谢楼主分享
 楼主| 发表于 2021-6-6 22:20 | 显示全部楼层

谢谢支持
发表于 2021-6-7 09:07 | 显示全部楼层
谢谢楼主分享!
发表于 2021-6-7 09:27 来自手机 | 显示全部楼层
好用,谢谢分享
发表于 2021-6-7 11:05 | 显示全部楼层
谢谢分享,又多了一偷懒工具
发表于 2021-6-7 12:40 | 显示全部楼层
不错,谢谢分享
发表于 2021-6-7 16:59 | 显示全部楼层
感谢分享,谢谢你的付出
发表于 2021-6-8 07:17 | 显示全部楼层
謝謝樓主分享
发表于 2021-6-8 09:12 | 显示全部楼层
谢谢楼主分享。。。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2020 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2021-6-16 06:36 , Processed in 1.239390 second(s), 29 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表